#include <stdio.h>
#include <stdlib.h>
// define cabealho do formato bitmap
typedef struct file_header {
    unsigned short file_type;
    unsigned int file_size;
    unsigned short reserved1;
    unsigned short reserved2;
    unsigned int offset;
} file_header;
// define cabealho do arquivo em questo
typedef struct info_header {
    unsigned int info_header_size;
    unsigned int width;
    unsigned int height;
    unsigned short planes;
    unsigned short bits;
    unsigned int compression;
    unsigned int size;
    unsigned int xdata_pixels_per_meter;
    unsigned int ydata_pixels_per_meter;
    unsigned int colors_used;
    unsigned int important_colors;
} info_header;

int main(){
    FILE *pointer_to_image;                       
    pointer_to_image = fopen("example.bmp", "rb"); 
    if (pointer_to_image == NULL)
        return 1;
    file_header header;
    info_header info;
    fread(&header, 14, 1, pointer_to_image); // l 14 bytes para cabealho
    fread(&info, 40, 1, pointer_to_image);   // l 40 bytes para info
    // instancia e aloca memria para dados de pixels
    unsigned char *data_pixels = (unsigned char*) malloc(info.size);  
    // l pixels da imagem para varivel data_pixels
    fread(data_pixels, info.size, 1, pointer_to_image);  
    fclose(pointer_to_image);
    FILE *pointer_to_new_image;
    pointer_to_new_image = fopen("new_example.bmp", "wb");
    // grava cabealhos da imagem nova
    fwrite(&header, 14, 1, pointer_to_new_image);
    fwrite(&info, 40, 1, pointer_to_new_image);
    // pinta todos os pixels de verde
    for (int i = 0; i < info.size; i+=3){
        data_pixels[i] = 0;		// blue
        data_pixels[i+1] = 255;	// green
        data_pixels[i+2] = 0; 	// red
    }
    // grava data_pixels na imagem nova
    fwrite(data_pixels, info.size, 1, pointer_to_new_image);
    fclose(pointer_to_new_image);
    return 0;
}